//  FileConfig.h version 1.1
//  yudit package - Unicode Editor for the X Window System (and Linux) 
//
//  Author: gsinai@iname.com (Gaspar Sinai)
//  GNU Copyright (C) 1997,1998  Gaspar Sinai
// 
//  yudit version 1.1  Copyright(C) 23 August,   1998, Tokyo Japan  Gaspar Sinai
//  yudit version 1.0  Copyright(C) 17 May,      1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.99 Copyright(C)  4 April,    1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.97 Copyright(C)  4 February, 1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.95 Copyright(C) 10 January,  1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.94 Copyright(C) 17 December, 1997, Tokyo Japan  Gaspar Sinai
//  yudit version 0.9 Copyright (C)  8 December, 1997, Tokyo Japan  Gaspar Sinai
//  yutex version 0.8 Copyright (C)  5 November, 1997, Tokyo Japan  Gaspar Sinai
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//
//
//

#ifndef __fileconfig_h__
#define __fileconfig_h__

#include "AString.h"
#include <iostream.h>
#include <fstream.h>

// This class supposed to imitate KConfig so kde config can be used.
// There is only one instance of this class in the app.

#ifndef CONFIG_PATH 
#define CONFIG_PATH 0
#endif

class FileConfig
{
public:
				FileConfig (const char* name);
				~FileConfig ();
	void			setGroup (const AString& group);
	int			readEntry (const char* key, AString& result);
	int			readEntries (const char* key, 
					AStringList &list,
					const char sep = ',');
	inline int		isOpen () 
				{ return (file!=0 && 
#ifdef gnu_iostream 
				(file->is_open())
#else 
				!(file->rdbuf() == 0 || !file->rdbuf()->is_open())
#endif
				); }
	inline const char*	getConfigPath () const {return pathName; };
private:
	char*			seekEntry (const char* entry);
	char*			expandEnv (const char* in, int size);
	AString			group;
	static char*		pathName;
	static char*		path;
	static ifstream*	file;
	static streampos	fileBegin;
};

#endif /* __fileconfig_h__ */
