//  UFindDialog.h version 1.1
//  yudit package - Unicode Editor for the X Window System (and Linux) 
//
//  Author: gsinai@iname.com (Gaspar Sinai)
//  GNU Copyright (C) 1997,1998  Gaspar Sinai
// 
//  yudit version 1.1  Copyright(C) 23 August,   1998, Tokyo Japan  Gaspar Sinai
//  yudit version 1.0  Copyright(C) 17 May,      1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.99 Copyright(C)  4 April,    1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.97 Copyright(C)  4 February, 1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.95 Copyright(C) 10 January,  1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.94 Copyright(C) 17 December, 1997, Tokyo Japan  Gaspar Sinai
//  yudit version 0.9 Copyright (C)  8 December, 1997, Tokyo Japan  Gaspar Sinai
//  yutex version 0.8 Copyright (C)  5 November, 1997, Tokyo Japan  Gaspar Sinai
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
#ifndef __ufind_dialog_h__
#define __ufind_dialog_h__

#include <UFont.h>
#include "UDialog.h"
#include "UTextFrame.h"
#include <AString.h>

class UFindDialog : public UDialog
{
public:
			// with frame
	enum USubComponent { FIND, REPLACE, CANCEL, FIND_LABEL, FIND_TEXT, 
			REPLACE_LABEL, REPLACE_TEXT, COMP_MAX};

			UFindDialog (UShell* transient, int frameSize=2);
			UFindDialog (UTop* top_, int frameSize=2);
	virtual		~UFindDialog ();

	// pop up, get value after popped down.
	virtual UValue	getValue();

	virtual const 	UBestSize&	getBestSize ();

	void		setButtonFont (UFont* font_);
	void		setTextFont (UFont* font_);
	void		setEntryFont (UFont* font_);
	void		setFindArea (UTextFrame* findArea);
	virtual void	resize (int w, int h);

	// the return value will be utf8 - this is the text encoding
	int		setEncoding (const char* encoding);
	int		setInput (const char* input);

	void		setText (USubComponent w_, const char* utf8_);
	void		eventUp (UEvent* event);
	const char*	getSelected ();
	int 		setXInput (const char* name, const char* imIn,
				const char* inputStyleIn, const char* textType,
				const char* uStringIn, const char* fontMap, 
				double versionIn=0.0);

private:
	int		findResult;
	UTextFrame*	findArea;
	USubComponent	lastButton;
	void		setUp();
	UComponent*	component[COMP_MAX];
	AString		selected;
};

#endif /* __find_dialog_h_ */
