//  UFrame.h version 1.1
//  yudit package - Unicode Editor for the X Window System (and Linux) 
//
//  Author: gsinai@iname.com (Gaspar Sinai)
//  GNU Copyright (C) 1997,1998  Gaspar Sinai
// 
//  yudit version 1.1  Copyright(C) 23 August,   1998, Tokyo Japan  Gaspar Sinai
//  yudit version 1.0  Copyright(C) 17 May,      1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.99 Copyright(C)  4 April,    1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.97 Copyright(C)  4 February, 1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.95 Copyright(C) 10 January,  1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.94 Copyright(C) 17 December, 1997, Tokyo Japan  Gaspar Sinai
//  yudit version 0.9 Copyright (C)  8 December, 1997, Tokyo Japan  Gaspar Sinai
//  yutex version 0.8 Copyright (C)  5 November, 1997, Tokyo Japan  Gaspar Sinai
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
#ifndef __uframe_h_
#define __uframe_h_

// A simple frame. It provides some simple geometry management as well
#include "UTop.h"
#include "UComponent.h"
#include "UColor.h"

class UFrame : public UComponent
{
public:
	enum UFrameStyle { IN, OUT, ETCHED_IN, ETCHED_OUT };
			UFrame  (UFrame* parent_, int frameSize=2);
	virtual		~UFrame ();

	void			setFrameStyle (UFrameStyle fstyle);

	virtual int		isA (UComponent::UType type);
	virtual void 		setBackground (const UColor& color);
	virtual void 		setBackground (const char* color);
	virtual void 		setForeground (const UColor& color);
	virtual void 		setForeground (const char* color);
	virtual void 		setFont (UFont* font);

	virtual void		resize (int width, int height);
	virtual void		move (int x, int y);
	virtual void 		redraw (int x, int y, int width, int height);

	virtual void		eventDown (UEvent* event);
	virtual void		eventUp (UEvent* event);
	virtual void 		addChild (UComponent* child);
	virtual void 		deleteChild (UComponent* child);
	virtual UComponent*	getParent ();
	inline int		getFrameSize () { return frameSize; }

	void			pack ();
	virtual int		isChild (Window w);

protected:
				// No window.
				UFrame  (UTop* top, int frameSize=2);

	short			frameSize;
	UColor			dark;
	UColor			light;
	GC			lightGC;
	GC			darkGC;

	// Only frames can have children
	UBinArray		children;
	UFrame*			parent;
	UFrameStyle		frameStyle;
};

#endif /* __uframe_h_ */
