//  UTextButton.cpp version 1.1
//  yudit package - Unicode Editor for the X Window System (and Linux) 
//
//  Author: gsinai@iname.com (Gaspar Sinai)
//  GNU Copyright (C) 1997,1998  Gaspar Sinai
// 
//  yudit version 1.1  Copyright(C) 23 August,   1998, Tokyo Japan  Gaspar Sinai
//  yudit version 1.0  Copyright(C) 17 May,      1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.99 Copyright(C)  4 April,    1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.97 Copyright(C)  4 February, 1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.95 Copyright(C) 10 January,  1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.94 Copyright(C) 17 December, 1997, Tokyo Japan  Gaspar Sinai
//  yudit version 0.9 Copyright (C)  8 December, 1997, Tokyo Japan  Gaspar Sinai
//  yutex version 0.8 Copyright (C)  5 November, 1997, Tokyo Japan  Gaspar Sinai
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
#include "UTextButton.h"

UTextButton::UTextButton  (UFrame* parent_, const char* text_, 
	UTextLine::UAlign align_, UButtonStyle style_) 
	: UButton (parent_, style_) 
{
	UComponent* child;
	child = new UTextLabel (this, text_, align_); 
	child->select (ExposureMask | ButtonPressMask |ButtonReleaseMask| 
		Button1MotionMask | LeaveWindowMask | EnterWindowMask);
}

UTextButton::~UTextButton()
{
	// autodelete 
}

void
UTextButton::setInsets (int w, int e)
{
	UTextLabel*	child;
	child = (UTextLabel*) children.at (0);
	if (child == 0) return;
	child->setInsets (w, e);
}
void
UTextButton::setText (const UCS2* text)
{
	UTextLabel*	child;
	child = (UTextLabel*) children.at (0);
	if (child == 0) return;
	child->setText (text);
}
void
UTextButton::setText (const unsigned char* text)
{
	UTextLabel*	child;
	child = (UTextLabel*) children.at (0);
	if (child == 0) return;
	child->setText (text);
}

void
UTextButton::setText (const char* text)
{
	UTextLabel*	child;
	child = (UTextLabel*) children.at (0);
	if (child == 0) return;
	child->setText (text);
}

const UBestSize&
UTextButton::getBestSize ()
{
	UComponent* child;
	child = (UComponent*) children.at (0);
	if (child == 0)
	{
		return (UButton::getBestSize ());
	}
	UBestSize bs = child->getBestSize();
	bs.width += defaultOffset * 2 + 2 * frameSize + 2 * placement.margin;
	bs.height += defaultOffset * 2 + 2 * frameSize + 2 * placement.margin;
	bestSize.width = bs.width;
	bestSize.height = bs.height;
	return bestSize;
}


int
UTextButton::isA (UComponent::UType type_)
{
	if (type_ == UComponent::TEXT_BUTTON) return 1;
	return UButton::isA (type_);
}
