//  UTop.h version 1.1
//  yudit package - Unicode Editor for the X Window System (and Linux) 
//
//  Author: gsinai@iname.com (Gaspar Sinai)
//  GNU Copyright (C) 1997,1998  Gaspar Sinai
// 
//  yudit version 1.1  Copyright(C) 23 August,   1998, Tokyo Japan  Gaspar Sinai
//  yudit version 1.0  Copyright(C) 17 May,      1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.99 Copyright(C)  4 April,    1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.97 Copyright(C)  4 February, 1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.95 Copyright(C) 10 January,  1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.94 Copyright(C) 17 December, 1997, Tokyo Japan  Gaspar Sinai
//  yudit version 0.9 Copyright (C)  8 December, 1997, Tokyo Japan  Gaspar Sinai
//  yutex version 0.8 Copyright (C)  5 November, 1997, Tokyo Japan  Gaspar Sinai
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//
// The top object that is attached to the display and screen.
//

#ifndef __utop_h__
#define __utop_h__
#include "UTopContext.h"
#include "UComponent.h"
#include "UEvent.h"
#include "UBinArray.h"
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>

class UTop : public UTopContext
{
public:
			UTop (void);
	virtual		~UTop ();
	void		init ();

	void		addShell (UComponent *shell);
	void		deleteShell (UComponent *shell);

	void		addComponent (UComponent *comp);
	UComponent*	findComponent (Window window);
	void		deleteComponent (UComponent *comp);
	void		addEventHandler (UEventHandler* handler, 
				unsigned long mask);
	void		removeEventHandler (UEventHandler* handler, 
				unsigned long mask);

	const unsigned char*	getClipboard (Window win, int* len=0);
	void		putClipboard (Window win, const unsigned char* clip, int size);
	virtual void 	clipEvent (XEvent* event);

private:
	const unsigned char*	getClipboard (Atom textType, Window win, int* len=0);
};

#endif /* __utop_h__ */
