//  UFontMap.h version 1.1
//  yudit package - Unicode Editor for the X Window System (and Linux) 
//
//  Author: gsinai@iname.com (Gaspar Sinai)
//  GNU Copyright (C) 1997,1998  Gaspar Sinai
// 
//  yudit version 1.1  Copyright(C) 23 August,   1998, Tokyo Japan  Gaspar Sinai
//  yudit version 1.0  Copyright(C) 17 May,      1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.99 Copyright(C)  4 April,    1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.97 Copyright(C)  4 February, 1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.95 Copyright(C) 10 January,  1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.94 Copyright(C) 17 December, 1997, Tokyo Japan  Gaspar Sinai
//  yudit version 0.9 Copyright (C)  8 December, 1997, Tokyo Japan  Gaspar Sinai
//  yutex version 0.8 Copyright (C)  5 November, 1997, Tokyo Japan  Gaspar Sinai
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//
//
//

#ifndef __ufontmap_h__
#define __ufontmap_h__

#include "UMap.h"

//
// 0 means not inited 1 means not available, rest is mapped.
#define UMAXFONTS	254

typedef struct _UFontMapStruct
{
	char*				foundry;
	char*				family;
	char*				registry;
	char*				encoding;
	char*				mapName;
	UMap*				encoder;
} UFontMapStruct;

//
// Big guy. Use just a few in the app.
//
class UFontMap
{
public:
	enum UStatus			{OK, ERROR};

					UFontMap (const char *nameIn); 
					~UFontMap();
	UStatus				addFont (const char* foundry, 
						const char* family, 
						const char* registry,
						const char* encoding, 
						const char *umap);
	UStatus				deleteLast();
	inline const char*		getName () const { return name; }
	int				size;
	UFontMapStruct*			fonts [UMAXFONTS];
	void				init ();
private:
	int				isInited;
	char*				name;
};

UFontMap::UStatus  UAddFontMap ( const char* name, const char* foundryIn, 
	const char* familyIn, const char* registryIn,
	const char* encodingIn, const char *umapIn);

UFontMap* UGetFontMap (const char *name);
UFontMap::UStatus UDeleteFontMap (const char *name);

#endif /* __ufontmap_h__ */
